﻿using Demo.EntityFrameworkCore;

using Microsoft.EntityFrameworkCore;

using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;

using Volo.Abp.Domain.Repositories.EntityFrameworkCore;
using Volo.Abp.EntityFrameworkCore;

namespace Demo
{
    public class TestRepository : EfCoreRepository<DemoDbContext, Test, Guid>, ITestRepository
    {
        public TestRepository(IDbContextProvider<DemoDbContext> dbContextProvider) : base(dbContextProvider)
        {
        }

        public override Task<List<Test>> GetListAsync(bool includeDetails = false, CancellationToken cancellationToken = new CancellationToken())
        {
            return DbSet.AsNoTracking().IncludeIf(includeDetails, x => x.Creator)
                .IncludeIf(includeDetails, x => x.LastModifier).IncludeIf(includeDetails, x => x.Deleter)
                .ToListAsync(cancellationToken: cancellationToken);
        }


    }
}